# coding: utf-8

"""
    Lead Scraping Service API

    Vector Lead Scraping Service API - Manages Lead Scraping Jobs

    The version of the OpenAPI document: 1.0
    Contact: yoanyomba@vector.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from playbookmedia_backend_client_sdk.models.job_success_rate import JobSuccessRate
from typing import Optional, Set
from typing_extensions import Self

class GetWorkspaceAnalyticsResponse(BaseModel):
    """
    GetWorkspaceAnalyticsResponse
    """ # noqa: E501
    total_leads: Optional[StrictInt] = Field(default=None, alias="totalLeads")
    active_workflows: Optional[StrictInt] = Field(default=None, alias="activeWorkflows")
    jobs_last30_days: Optional[StrictInt] = Field(default=None, alias="jobsLast30Days")
    success_rates: Optional[List[JobSuccessRate]] = Field(default=None, alias="successRates")
    __properties: ClassVar[List[str]] = ["totalLeads", "activeWorkflows", "jobsLast30Days", "successRates"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetWorkspaceAnalyticsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in success_rates (list)
        _items = []
        if self.success_rates:
            for _item in self.success_rates:
                if _item:
                    _items.append(_item.to_dict())
            _dict['successRates'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetWorkspaceAnalyticsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "totalLeads": obj.get("totalLeads"),
            "activeWorkflows": obj.get("activeWorkflows"),
            "jobsLast30Days": obj.get("jobsLast30Days"),
            "successRates": [JobSuccessRate.from_dict(_item) for _item in obj["successRates"]] if obj.get("successRates") is not None else None
        })
        return _obj


