# coding: utf-8

"""
    Lead Scraping Service API

    Vector Lead Scraping Service API - Manages Lead Scraping Jobs

    The version of the OpenAPI document: 1.0
    Contact: yoanyomba@vector.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class SignatureBlock(BaseModel):
    """
    SignatureBlock
    """ # noqa: E501
    id: Optional[StrictStr] = None
    request_id: Optional[StrictStr] = Field(default=None, alias="requestId")
    block_type: Optional[StrictStr] = Field(default=None, alias="blockType")
    page_number: Optional[StrictInt] = Field(default=None, alias="pageNumber")
    x_position: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="xPosition")
    y_position: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="yPosition")
    width: Optional[Union[StrictFloat, StrictInt]] = None
    height: Optional[Union[StrictFloat, StrictInt]] = None
    is_required: Optional[StrictBool] = Field(default=None, alias="isRequired")
    signature_data: Optional[StrictStr] = Field(default=None, alias="signatureData")
    signed_at: Optional[datetime] = Field(default=None, alias="signedAt")
    __properties: ClassVar[List[str]] = ["id", "requestId", "blockType", "pageNumber", "xPosition", "yPosition", "width", "height", "isRequired", "signatureData", "signedAt"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SignatureBlock from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SignatureBlock from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "requestId": obj.get("requestId"),
            "blockType": obj.get("blockType"),
            "pageNumber": obj.get("pageNumber"),
            "xPosition": obj.get("xPosition"),
            "yPosition": obj.get("yPosition"),
            "width": obj.get("width"),
            "height": obj.get("height"),
            "isRequired": obj.get("isRequired"),
            "signatureData": obj.get("signatureData"),
            "signedAt": obj.get("signedAt")
        })
        return _obj


